/*************************************************************************************
 *  Copyright (C) 2007-2008 by Aleix Pol <aleixpol@gmail.com>                        *
 *                                                                                   *
 *  This program is free software; you can redistribute it and/or                    *
 *  modify it under the terms of the GNU General Public License                      *
 *  as published by the Free Software Foundation; either version 2                   *
 *  of the License, or (at your option) any later version.                           *
 *                                                                                   *
 *  This program is distributed in the hope that it will be useful,                  *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of                   *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                    *
 *  GNU General Public License for more details.                                     *
 *                                                                                   *
 *  You should have received a copy of the GNU General Public License                *
 *  along with this program; if not, write to the Free Software                      *
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA   *
 *************************************************************************************/

#ifndef OPERATIONS_H
#define OPERATIONS_H

#include "operator.h"

#include <QStringList>

class Cn;
class Container;

class Operations
{
	public:
		static Object* reduce(Operator::OperatorType op, Object* oper, Object* oper1, bool &correct);
		static Object* reduceUnary(Operator::OperatorType op, Object* oper, bool &correct);
		
	private:
		static Cn* reduceRealReal(Operator::OperatorType op, Cn *oper, const Cn* oper1, bool &correct);
		static Cn* reduceUnaryReal(Operator::OperatorType op, Cn *oper, bool &correct);
		
		static Object* reduceRealVector(Operator::OperatorType op, Cn *oper, Container* vector, bool &correct);
		static Object* reduceVectorReal(Operator::OperatorType op, Container* vector, Cn *oper, bool &correct);
		static Object* reduceVectorVector(Operator::OperatorType op, Container* v1, Container* v2, bool &correct);
		static Object* reduceUnaryVector(Operator::OperatorType op, Container* c, bool &correct);
};

#endif
